function [u_x_t_dD_tt,r_e]=exact_solution_dD_tt(d,x,t,xita,ex)
% u_x_t_dD_tt, exact solution in TT format, d dimensional case
% r_e, TT rank of exact solution

% d spatial dimension
% x spatial coordinates (M-by-1)
% t time coordinates (N-by-1)
% xita  order of time fractional derivative
% ex example chosen


r_e=ones(1,d+1);
switch ex
    case 1 
        u_x_t_dD_tt=repmat({permute((x.*(2-x)).^2,[3,2,1])},1,d);
        u_x_t_dD_tt{d+1}=permute(t.^(2+xita),[3,2,1]);
    case 2 
        u_x_t_dD_tt=repmat({permute((x.*(2-x)).^4,[3,2,1])},1,d);
        u_x_t_dD_tt{d+1}=permute(t.^2+1,[3,2,1]);
end