function f_x_t_3d=source_term_3D_mtx(x,a,x_left_coef,x_right_coef,t,xita,ex)
% f_x_t_3d, source term in matrix format, 3 dimensional case

% x spatial coordinates (M-by-1)
% a  order of space fractional derivative (1-by-d)
% x_left_coef,x_right_coef  left and right coeffficient of space fractional derivative (1-by-d)
% t time coordinates (N-by-1)
% xita  order of time fractional derivative
% ex example chosen

switch ex
    case 1
      
x_L_D_u_0=bsxfun(@times,gamma(5)./gamma(5-a),bsxfun(@power,x,4-a))...
    -4*bsxfun(@times,gamma(4)./gamma(4-a),bsxfun(@power,x,3-a))...
    +4*bsxfun(@times,gamma(3)./gamma(3-a),bsxfun(@power,x,2-a));
        xx=2-x;
x_R_D_u_0=bsxfun(@times,gamma(5)./gamma(5-a),bsxfun(@power,xx,4-a))...
    -4*bsxfun(@times,gamma(4)./gamma(4-a),bsxfun(@power,xx,3-a))...
    +4*bsxfun(@times,gamma(3)./gamma(3-a),bsxfun(@power,xx,2-a));
u_x=( (x.*xx).^2); % x 1D

end


%% Gen P1
u_xy=u_x*u_x.'; % xy 2D
u_z(1,1,:)=u_x;
P1=bsxfun(@times,u_xy,u_z); %3D (x1,x2,x3)

%% Gen P2
% fraction der in 1,2,3 d
x_D_123=bsxfun(@times,x_left_coef,x_L_D_u_0)+bsxfun(@times,x_right_coef,x_R_D_u_0); % n-by-3

temp_uxy=x_D_123(:,1)*u_x.'+u_x*x_D_123(:,2).';
P2=bsxfun(@times,temp_uxy,u_z);
temp_uz(1,1,:)=x_D_123(:,3);
P2=P2+bsxfun(@times,u_xy,temp_uz);

%% Source term

f_t(1,1,1,:)=(  0.5*gamma(3+xita) ) * t.^2;
f_t2(1,1,1,:)= t.^(2+xita);

f_x_t_3d=bsxfun(@times,P1,f_t) - bsxfun(@times, P2 , f_t2 );





