function [f_x_t_dD_tt,r_s]=source_term_dD_tt(d,x,alpha_sq,x_left_coef,x_right_coef,t,xita,ex)
% f_x_t_dD_tt, source_term in TT format, d dimensional case
% r_s, TT rank of source_term

% d spatial dimension
% x spatial coordinates (M-by-1)
% alpha_sq % order of fractional derivative (1-by-d)
% x_left_coef,x_right_coef  left and right coefficient of space fractional derivative (1-by-d)
% t time coordinates (N-by-1)
% xita  order of time fractional derivative
% ex example chosen

        i_x=length(x);

       
if ex==3
        f_x_t_dD_tt=cell(1,d+1);r_s=ones(1,d+1);
        mg=0.5;
        ma=pi;mb=1;r=3;
        x=permute(x,[3,2,1]);
        f_x_t_dD_tt{1}=mg*[cos(ma*x),sin(ma*x),log(1+mb*x)];
        for k=2:d
            f_x_t_dD_tt{k}=mg*[cos(ma*x),sin(ma*x),log(1+mb*x);log(1+mb*x),cos(ma*x),sin(ma*x);sin(ma*x),log(1+mb*x),cos(ma*x)];
        end
        f_x_t_dD_tt{d+1}=mg*[t;t.^2;t.^3];
        r_s=r*r_s;r_s(d+1)=1;   
    
    return
end
       
       
        f_x_t_dD_tt=cell(1,d+1);r_s=[3*ones(1,d-1),2,1];
switch ex
     
      case 1

x_L_D_u_0=bsxfun(@times,gamma(5)./gamma(5-alpha_sq),bsxfun(@power,x,4-alpha_sq))...
    -4*bsxfun(@times,gamma(4)./gamma(4-alpha_sq),bsxfun(@power,x,3-alpha_sq))...
    +4*bsxfun(@times,gamma(3)./gamma(3-alpha_sq),bsxfun(@power,x,2-alpha_sq));
        xx=2-x;
x_R_D_u_0=bsxfun(@times,gamma(5)./gamma(5-alpha_sq),bsxfun(@power,xx,4-alpha_sq))...
    -4*bsxfun(@times,gamma(4)./gamma(4-alpha_sq),bsxfun(@power,xx,3-alpha_sq))...
    +4*bsxfun(@times,gamma(3)./gamma(3-alpha_sq),bsxfun(@power,xx,2-alpha_sq));
X=permute((x.*xx).^2,[3,2,1]);  
    case 2

x_L_D_u_0=16*bsxfun(@times,gamma(5)./gamma(5-alpha_sq),bsxfun(@power,x,4-alpha_sq))...
    -32*bsxfun(@times,gamma(6)./gamma(6-alpha_sq),bsxfun(@power,x,5-alpha_sq))...
    +24*bsxfun(@times,gamma(7)./gamma(7-alpha_sq),bsxfun(@power,x,6-alpha_sq))...
    -8*bsxfun(@times,gamma(8)./gamma(8-alpha_sq),bsxfun(@power,x,7-alpha_sq))...
    +bsxfun(@times,gamma(9)./gamma(9-alpha_sq),bsxfun(@power,x,8-alpha_sq));
        xx=2-x;
        x_R_D_u_0=16*bsxfun(@times,gamma(5)./gamma(5-alpha_sq),bsxfun(@power,xx,4-alpha_sq))...
    -32*bsxfun(@times,gamma(6)./gamma(6-alpha_sq),bsxfun(@power,xx,5-alpha_sq))...
    +24*bsxfun(@times,gamma(7)./gamma(7-alpha_sq),bsxfun(@power,xx,6-alpha_sq))...
    -8*bsxfun(@times,gamma(8)./gamma(8-alpha_sq),bsxfun(@power,xx,7-alpha_sq))...
    +bsxfun(@times,gamma(9)./gamma(9-alpha_sq),bsxfun(@power,xx,8-alpha_sq));
X=permute((x.*xx).^4,[3,2,1]);   
end
O=zeros(1,1,i_x);
x_D=permute(bsxfun(@times,x_left_coef,x_L_D_u_0)+bsxfun(@times,x_right_coef,x_R_D_u_0),[3,2,1]);
f_x_t_dD_tt{1}=[X,x_D(1,1,:),X];
for n=2:d-1
    f_x_t_dD_tt{n}=[X,O,O;O,X,O;O,x_D(1,n,:),X];
end
f_x_t_dD_tt{d}=[X,O;O,X;O,x_D(1,d,:)];
if ex==1
    f_x_t_dD_tt{d+1}=[(0.5*gamma(3+xita))*t.^2;-t.^(2+xita)];
else % ex==2
    f_x_t_dD_tt{d+1}=[(gamma(3)/gamma(3-xita))*t.^(2-xita);-(t.^2+1)];
end